///////A workable method for determining position in a chain of similar nodes and assigning i2c addresses, released 06/01/17/////////
///////Author: Fergus Riche, fr293@cam.ac.uk////////////////////////////


// we need wire to make i2c connections, this is the standard library
// address pins 0 and 1 to be the input and output pins, use pin 2 as a readout

#include <Wire.h>
#define in A4
#define out A3
#define blue A0
#define green A1
#define red A2
#define enbl 8

// initialise the i2c address as zero

int address = 0;

// this runs at the start and handles the node position identification routine 

void setup() {

//enable the VBUS pin
  USBCON|=(1<<OTGPADE); 

// middle and wait are used to show if the node is in the middle of the line, and if it should wait

  bool middle = false;
  bool wait = false;

// the pins must be set correctly for their modes of operation

  pinMode(in, INPUT);
  pinMode(out, OUTPUT);
  pinMode(enbl, OUTPUT);
  pinMode(red, OUTPUT);
  pinMode(green, OUTPUT);
  pinMode(blue, OUTPUT);
 
  digitalWrite(enbl,HIGH);
              
  if(USBSTA&(1<<VBUS)){
    address = 1;
    Wire.begin(address);
      delay(100);
    digitalWrite(out, HIGH);
            }

// if we are in the middle, then wait until the in line goes high, then search for the first unoccupied address
// assign this address and raise the out line high for the next node

  else{
    Wire.begin();
    digitalWrite(red,HIGH);
    delay(100);
    while(!wait){
      wait = digitalRead(in);
      delay(100);
                }
    digitalWrite(red,LOW);
    delay(100);
                
       address = sweeper();
       Wire.begin(address);
       digitalWrite(out, HIGH);
      }
}

// output the address as a blink pattern

void loop() {
  // put your main code here, to run repeatedly:
  delay(1000);
  blink(blue, address);
            }

// sweeper engages master mode and searches for the first unoccupied address on the i2c bus

int sweeper() {
  int i = 2;
  int trans = 0;
  bool check = false;
  while(!check){
  Wire.beginTransmission(i);
  trans = Wire.endTransmission();
  if(trans == 2){
    check = true;
                }
  else{
   i++;               
      }
               }
         return i;
              }

void blink(int pin, int num) { 
  for(int i = 0; i < num; i++){
    digitalWrite(pin,HIGH);
    delay (200);
    digitalWrite(pin,LOW);
    delay (200);
                           }
                    }
